﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CimSyntaxGen.AsciiDoc
{
    public class AsciiDocStyle
    {
        public AsciiDocStyle() { }

        public string NumberingOn()
        {
            return ":sectnums:\n";
        }

        public string NumberingOff()
        {
            return ":sectnums!:\n";
        }

        public string GetHeader(string title, int level)
        {
            StringBuilder sb = new StringBuilder("\n");
            level++;
            for (int i = 0; i < level; i++)
            {
                sb.Append("=");
            }
            sb.Append(" " + title);
            sb.Append("\n\n");
            return sb.ToString();
        }



    }
}
