using System;
using System.IO;


/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.3.7                                         *    march 2019 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen
{
    public sealed class ConstDefinition
    {
        /*
           private string EnumStereotype = "enumeration";
           private string DatatypeStereotype = "Datatype";
           private string PrimitiveStereotype = "Primitive";
           private string IsBasedOnStereotype = "IsBasedOn";

           private string StringType = "String";
           private string EnumType = "enumeration";
           private string BooleanType ="Boolean";
           private string IntegerType ="Integer";
           private string FloatType ="Float";
           //will need to add it as  a primitive type so that when you click on facet it give you the right window
           private string DecimalType = "Decimal";
           //
           private bool CheckExpirationDate = true;

           public enum VariableType{
               Numeric,
               Defined,
               Any
           }
   */
       
        public string NS_RDF = "http://www.w3.org/1999/02/22-rdf-syntax-ns#";
        public string NS_CIMS = "http://iec.ch/TC57/1999/rdf-schema-extensions-19990926#";
        public string NS_OWL = "http://www.w3.org/2002/07/owl#";
        public string NS_DC = "http://purl.org/dc/elements/1.1/";
        public string NS_XSD = "http://www.w3.org/2001/XMLSchema#";
        public string NS_J0 = "http://iec.ch/TC57/";
        public string NS_DAML = "http://www.daml.org/2001/03/daml+oil#";
        public string NS_RDFS = "http://www.w3.org/2000/01/rdf-schema#";
        public string NS_NONSTANDARD = "http://iec.ch/TC57/NonStandard/UML#";
        public string NS_OMGS = "http://www.omg.org/schema/utility/99-10-03#M:";
        public string NS_CC = "http://www.entsoe.eu/fileadmin/user_upload/edi/library/core/etso-code-lists.xsd";
        public long CONEND_NONAGREG= 0;
        public long CONEND_SHARED = 1;
        //am march 2017//public string ReportGen= Directory.GetCurrentDirectory() + "\\" + "CimSyntaxGenReport.txt";
        public string ReportGen = null; // am march 2017


       public  ConstDefinition()
        {
            ReportGen = FileManager.GetParentDirPath() + "\\CimSyntaxGenReport.log";
        }
    }
}