﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;



/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.4.4                                        *   january 2020 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen
{
    public partial class DialGenerXSD : Form
    {

         
           volatile  bool _go=true;


            public bool  go
            {
                get
                {
                    return _go;
                }
            }
           
           
     public DialGenerXSD()
     {
 InitializeComponent();
            this.button1.Visible = false;
            this.button1.Enabled = false;
        }
            /*************************************/
        
        public DialGenerXSD(string name)
        {
            
            InitializeComponent();
            this.Name = name;
            this.Text = name;
            this.button1.Visible = false;
            this.button1.Enabled = false;


            /*************************************/
        }
        public DialGenerXSD(string name,bool cancel)
        {

            InitializeComponent();
            this.Name = name;
            this.Text = name;
            if(cancel)
            {
                this.button1.Visible = true;
                this.button1.Enabled = true;
            }
            else
            {
                this.button1.Visible = false;
                this.button1.Enabled = false;
            }

            /*************************************/
        }
    
  
        public void setmax(int max)
        {
            // traitement de la barre
          //  MessageBox.Show(" progressbar setmax min=" + this.progressBar1.Minimum + ",value=" + this.progressBar1.Value + ",max=" + this.progressBar1.Maximum);
            this.CenterToScreen();
            this.BringToFront();
            // Display the ProgressBar control.
            this.progressBar1.Visible = true;
            // Set Minimum to 1 to represent the first file being copied.
            this.progressBar1.Minimum = 1;
            // Set Maximum to the total number of files to copy.
            this.progressBar1.Maximum = max;
            // Set the initial value of the ProgressBar.
            this.progressBar1.Value = 1;
            // Set the Step property to a value of 1 to represent each file being copied.
            this.progressBar1.Step = 1;
			
        }
        public bool progress()
        {
          //  MessageBox.Show(" progressbar progress  min=" + this.progressBar1.Minimum + ",value=" + this.progressBar1.Value + ",max=" + this.progressBar1.Maximum);
            // Perform the increment on the ProgressBar.
            if (!_go) return false;
            if (this.progressBar1.Value >= 100)
            {
                this.progressBar1.Value = progressBar1.Minimum;
                
            }
            this.progressBar1.PerformStep();
            return true;
        }
        public void scale()
        {
            //this.progressBar1.Scale();
        }
        public void invisible()
        {
            this.progressBar1.Visible = false;
        }
        public void resetmax(int max)
        {
            if (max == 0) max = 1; // pour empecher la value d'etre inferieure au max
          //  MessageBox.Show(" progressbar resetmax min=" + this.progressBar1.Minimum + ",value=" + this.progressBar1.Value + ",max=" + this.progressBar1.Maximum);
            this.progressBar1.Visible = true;
            // Set Minimum to 1 to represent the first file being copied.
            this.progressBar1.Minimum = 1;
            // Set Maximum to the total number of files to copy.
            this.progressBar1.Maximum = max;
            // Set the initial value of the ProgressBar.
            this.progressBar1.Value = 1;
            // Set the Step property to a value of 1 to represent each file being copied.
            this.progressBar1.Step = 1;
            // set the _stop variable to true
            this._go = true;
        }
        public void withcancel(bool with)
        {
            if (with)
            {
                this.button1.Enabled = true;
            }
            else
            {
                this.button1.Enabled = false;
            }
        }
        private void DialGenerXSD_KeyDown(object sender, KeyEventArgs e)
        {
           // MessageBox.Show(" sender :" + sender.ToString() + "clef:" + e.KeyCode.ToString());

        }

       void progressBar1_Click(object sender, KeyEventArgs e)
        {
           // MessageBox.Show(" essai :" + e.KeyCode.ToString());
        }

       private void button1_click(object sender, EventArgs e)
       {
           try
           {
              // MessageBox.Show(" essai :" + e.ToString());
             //  worker.RequestStop();
              // RDFLAutilitaires.reportlog.WriteLine (" click " );
              // RDFLAutilitaires.ongoing = false;
               this._go = false;
              // RDFLAutilitaires.// if(Main.DO_REPORTLOG) reportlog.WriteLine(" after click stop=" + _go.ToString());
              //if(RDFLAutilitaires.reportlog!=null) RDFLAutilitaires.// reportlog.Flush();         
           }
           catch (Exception exp)
           {
                //MessageBox.Show("exception cancel" + exp.Message);
                //if (Main.DO_REPORTLOG) RDFLAutilitaires.reportlog.WriteLine(" Dialgener le thread est aborte " + exp.Message +","+ exp.GetType().ToString());
              _go = false;
              //if (RDFLAutilitaires.reportlog != null) RDFLAutilitaires.// reportlog.Flush();
               this.Close();
           }
       }
    }
          
}
