﻿using System.Collections.Generic;

namespace CimSyntaxGen.JsonMaster
{
    public class XOROwner
    {
        private List<long> connList = new List<long>();
        private EA.Element owner;

        public XOROwner(EA.Element owner) { this.owner = owner; }

        public XOROwner(EA.Element owner, long[] connIDs) { 
            this.owner = owner; 
            this.connList.AddRange(connIDs);
        }

        public void AddConnector(long connID)
        {
            connList.Add(connID);
        }

        public EA.Element GetOwner() { return owner; }

        public List<long> GetConnList() {  return connList; }
    }
}
