using System;
using System.Windows.Forms;
using System.IO;
using System.Collections.Generic;
using System.Collections;
using Microsoft.VisualBasic;
using System.Diagnostics;
using System.ComponentModel;
using CimSyntaxGen.Option;
//using CimExportImport;
//using CimExportImport.manageIBO;
using CimSyntaxGen.manageIBO;
using System.Threading;
using EA;


namespace CimSyntaxGen
{
	public class Main
	{
		public string filecontents = "";
        static public int erreurs = 0; // marqueur des erreurs
		public bool readline = false;
		private bool m_ShowFullMenus = false;
		public Form1 theForm;
     	private EA.Repository ModelsContainer;
        static long parentid = 0;
        static ConstantDefinition CD = new ConstantDefinition();
        static public XMLParser XMLP;
          // indicateurs pour la sortie selon les options choisies
         static public Dictionary<string, Dictionary<string, bool>> IndStereos=new Dictionary<string, Dictionary<string, bool>>(); // stereo /  xmlbase,NBS
      public static   Dictionary<string, TextWriter> dicTwbyStereotype = new Dictionary<string, TextWriter>(); // dictionary of stream writers according to export stereotypes
       
        public static EA.Repository Repo; //am juil 2013
        public static List<string> entsoeSelectedStereotypes;
        /*
       public  List<string> Cimstereos = new List<string>()
                                      {
	                                    "Class",
	                                    "Datatype",
                                        "Primitive",
	                                    "Compound",
	                                    "enumeration",
                                       };
         * */
       // These are the Win32 error code for file not found or access denied.
       const int ERROR_FILE_NOT_FOUND = 2;
       const int ERROR_ACCESS_DENIED = 5;


        /************************************************************************************/
        /*            les dictionnaires des applications                                    */
        /************************************************************************************/
        public   class MyList<T> : List<T>
        {
           T retour;
           public MyList()
           {
               new List<T>();
           }
           public T First()
           {

               foreach (T t in this)
               {
                   retour = t;
                   break;
               }
               return retour;
           }
       }
       static Dictionary<string, MyList<EA.Element>> dicElemByName;  //  name;ArrayList fo elements
       static Dictionary<string, EA.Element> dicProfElemByName; // les elements du profile a creer
       static Dictionary<string, EA.Element> dicCIMElemByName; // tous les elements de CIMM qui peuvent tre parent 
       static Dictionary<string, EA.Element> dicCIMElemByGUID; // tous les elements de CIMM qui peuvent tre parent
       static Dictionary<long, EA.Element> dicCIMElemByID;

    
        /************************************************************************************/
		//Called Before EA starts to check Add-In Exists
		public String EA_Connect(EA.Repository Repository)
		{
			//No special processing required.
			return "a string";
		}//C:\Users\andre\Documents\zamiren\cimcontextor\CimSyntaxGen\Option\XMLProfileParameters.cs

		//Called when user Click Add-Ins Menu item from within EA.
		//Populates the Menu with our desired selections.
		public object EA_GetMenuItems(EA.Repository Repository, string Location, string MenuName) 
		{
			EA.Package aPackage = Repository.GetTreeSelectedPackage();
            Repo = Repository; //am juil 2013
			switch( MenuName )
			{
				case "":
					return "-CimSyntaxGen";
				case "-CimSyntaxGen":
                             XMLP = new XMLParser();

                    if (XMLP.GetXmlValueConfig("EntsoeManageCodeLits") == "Checked")  // am june 2015
                    {
                        //string[] ar = { "-RDF", "OWL", "-XSD", "-HtmlDocumentation", "-ManageCodeLists", "Options", "About..." };
                        string[] ar = { "-RDF","-XSD", "-HtmlDocumentation", "-ManageCodeLists", "Options", "About..." };
                        return ar;
                    }
                    else
                    {
                        //string[] ar = { "-RDF", "OWL", "-XSD", "-HtmlDocumentation", "Options", "About..." };
                        string[] ar = { "-RDF","-XSD", "-HtmlDocumentation", "Options", "About..." };
                        return ar;
                    }
					
                case "-RDF":  
                  string[] br = {"RDFS(501)","RDFS (augmented)" };
                    return br;
                case "OWL":
                    string cr = "OWL";
                    return cr;
                case "-XSD":
                    //string[] dr = { "XSD WG19", "XSD WG19 byref","XSD WG14", "XSD WG16", "XsdToProf" };
                    string[] dr = { "XSD WG19", "XSD WG19 byref", "XSD WG16", "XsdToProf" };
                  
                    return dr;
                case "-HtmlDocumentation":
                   // string[] er = {"HtmlDocumentation","ESMPHtmlDocumentation"};
                     XMLP = new XMLParser();
                      
                     if (XMLP.GetXmlValueConfig("HarmonisationEnabled") == "Checked")  // am june 2013
                     {
                         string[] er = { "HtmlDocumentation", "-ESMPHtmlDocumentation", "HtmlENTSOEDocumentation", "HtmlHarmonisationDocumentation" };
                     return er;
                     }
                     else
                     {
                          string [] er = { "HtmlDocumentation", "-ESMPHtmlDocumentation", "HtmlENTSOEDocumentation" };
                     return er;
                     }
               
                case "-ESMPHtmlDocumentation":
                    string[] era = { "Contextual and Assembly", "Creation 351", "FullPackage", "ENTSO-E documentation",};
                    return era;
                case "Options":
                    string es = "Options";
                    return es;
                case "-ManageCodeLists":
                    
                        string[] et = { "ImportCodeLists", "ExportCodeLists"};
                        return et;                  
			}

			return "";
		}
		
		//Sets the state of the menu depending if there is an active project or not
		bool IsProjectOpen(EA.Repository Repository)
		{
			try
			{
				EA.Collection c = Repository.Models;
				ModelsContainer=Repository;
				return true;
			}
			catch
			{
				return false;
			}
		}

		//Called once Menu has been opened to see what menu items are active.
		public void EA_GetMenuState(EA.Repository Repository, string Location, string MenuName, string ItemName, ref bool IsEnabled, ref bool IsChecked)
		{
			if( IsProjectOpen(Repository) )
			{
                if (ItemName == "-RDF")
					IsChecked = m_ShowFullMenus;
				else if( ItemName == "-XSD")
					IsEnabled = m_ShowFullMenus;
			}
			else
				// If no open project, disable all menu options
				IsEnabled = false;
		}

		//Called when user makes a selection in the menu.
		//This is your main exit point to the rest of your Add-in
		public void EA_MenuClick(EA.Repository Repository, string Location, string MenuName, string ItemName)
		{
            //ConstantDefinition CD = new ConstantDefinition();
            DateTime ActualDate = DateTime.Now;

            if (CD.GetExpirationCheckState())
            {
                if (!(ActualDate < CD.GetExpirationDate()))
                {
                    ExpiredForm EF = new ExpiredForm();
                    EF.ShowDialog();
                    return;
                }
            }
				
			switch( ItemName )
			{
				case "-RDF":	

                       MessageBox.Show(" RDF");
					
				break;

                		case "RDFS(501)":	

                             		 MontraitementRDF( Repository) ;
                
					break;

				case "RDFS (augmented)":
                         // MessageBox.Show("Non yet implemented RDFS (augmented)");
                       		 MontraitementRDFLA( Repository) ;
					break;

				case "OWL":	

                       MessageBox.Show("Not yet implemented OWL");
                    /*
                       ConstDefinition constantes = new ConstDefinition();
                       try
                       {
                           RDFLAutilitaires.reportlog = new StreamWriter(constantes.ReportGen); //  the report file
                           RDFutilitaires.reportlog = (StreamWriter)RDFLAutilitaires.reportlog;
                           Thread t = new Thread(WriteY);
                           t.Start();
                           // simultaneously, do something
                           for (int i = 0; i < 1000; i++)
                           {
                               RDFLAutilitaires.reportlog.WriteLine("x");
                           }
                            return;
                       }
                       catch (Exception e)
                       {
                           MessageBox.Show(" Error when opening file " + constantes.ReportGen);
                           return;
                       }
					*/
					break;
                                					
				case "-XSD":	

                       MessageBox.Show("to XML schemas");
					
					break;
                case "XSD WG19":
                    //MessageBox.Show("Not yet implemented  XSD WG19");
              //      XMLProfileParameters profparameters = new XMLProfileParameters();
               //     Dialxsd aDialxsd = new Dialxsd(profparameters);
                //    aDialxsd.ShowDialog();		
                    MonTraitementXSD(Repository,"wg19");
                    break;
                   
                case "XSD WG19 byref":
                   // MessageBox.Show("Not yet implemented  XSD WG19 byref");
                    //      XMLProfileParameters profparameters = new XMLProfileParameters();
                    //     Dialxsd aDialxsd = new Dialxsd(profparameters);
                    //    aDialxsd.ShowDialog();		
                    MonTraitementXSD(Repository, "wg19byref");
                    break;
               case "XSD WG14":
                    //MessageBox.Show("Not yet implemented");
                    MonTraitementXSD(Repository,"wg14");
                    break;
               case "XSD WG16":
                   // MessageBox.Show("Not yet implemented  XSD WG16");
                    MonTraitementXSD(Repository, "wg16");
                    break;
                case "XsdToProf" :
                   // MessageBox.Show(" not yet implemented");
                    /*********/
                    EA.Package package = Repository.GetTreeSelectedPackage();
                    try
                    {
                        List<EA.Package> allpackages=new List<EA.Package>();
                        EA.Package toppack = RDFutilitaires.GetModelPackage(package, Repo);
                        RDFutilitaires.getAllPackages(toppack, allpackages);
                        foreach (EA.Package pa in allpackages)
                        {
                            if (!RDFutilitaires.dicpackbyid.ContainsKey(pa.PackageID))
                            {
                                RDFutilitaires.dicpackbyid.Add(pa.PackageID, pa);
                            }
                        }
                        List<long> CIMpackageids = new List<long>();

                        // ProfileIBOPackagesID= getParentPackages(package.PackageID,RDFutilitaires.dicpackbyid ,packageids);
                        getCIMPackageslist(package, CIMpackageids);

                        DialFile dfil = new DialFile();
                        dfil.ShowDialog();



                        GenerprofilesFromXSD gxsd = new GenerprofilesFromXSD(Repository, "");
                        //if (CimExportImport.manageIBO.ManageIBOUtilitaires.reportlog != null) CimExportImport.manageIBO.ManageIBOUtilitaires.reportlog.Close();
                        if (manageIBO.ManageIBOUtilitaires.reportlog != null) manageIBO.ManageIBOUtilitaires.reportlog.Close();
                    }
                    catch (Exception e)
                    {
                        erreurs = erreurs + 1;
                        if (manageIBO.ManageIBOUtilitaires.reportlog != null)
                        {
                            manageIBO.ManageIBOUtilitaires.reportlog.WriteLine("error xsdtoprof" + e.Message);
                            manageIBO.ManageIBOUtilitaires.reportlog.Close();
                        }
                        else
                        {
                            MessageBox.Show(" ERROR in xsdtoprof " + e.Message);
                        }
                    }
                    if (erreurs > 0)
                    {
                        MessageBox.Show("the end  some errors or warnings can be found in file GenerprofilesFromXSD.log");
                    }
                    else
                    {
                        MessageBox.Show("the end");
                    }
                    /***************/
                    break;
                case "-HtmlDocumentation":
                    MessageBox.Show("-HtmlDocumentation");
                    break;
               case "HtmlDocumentation":

                //    MessageBox.Show("Not yet implemented HtmlDocumentation");
                    prodHtmlDocumentation(Repository, "HtmlDocumentation");
                    break;
               case "HtmlENTSOEDocumentation":

                    //    MessageBox.Show("Not yet implemented HtmlDocumentation");
                    prodHtmlDocumentation(Repository, "HtmlENTSOEDocumentation");
                    break;
               case "HtmlHarmonisationDocumentation":

                    //    MessageBox.Show("Not yet implemented HtmlDocumentation");
                    prodHtmlDocumentation(Repository, "HtmlHarmonisationDocumentation");
                    break;
               case "-ESMPHtmlDocumentation":

                    //    MessageBox.Show("Not yet implemented HtmlDocumentation");
                  
                    break;
                case "Contextual and Assembly" :
                    //MessageBox.Show(" not yet implemented");
                    prodHtmlDocumentation(Repository, "ESMPHtmlDocumentationAC");
                     break;
                case "Creation 351" :
                  prodHtmlDocumentation(Repository, "ESMPHtmlDocumentation");
                    break;
                case "Contextual an Assembly for IEC":
                    prodHtmlDocumentation(Repository, "ESMPHtmlDocumentationACForIEC");
                    break;


                case  "FullPackage":
                    //MessageBox.Show("not yet implemented");
                    prodHtmlDocumentation(Repository, "ESMPHtmlDocumentationall");
                    break;
                case "ENTSO-E documentation":
                    //MessageBox.Show("not yet implemented");
                    prodHtmlDocumentation(Repository, "ESMPHtmlDocumentationSpecific");
                    break;

               case "Options":
                    //    MessageBox.Show("Not yet implemented Options");
                    XMLProfileParameters profparam = new XMLProfileParameters();
                    OptionForm oform= new OptionForm(profparam);
                    oform.Show();
                    break;
				case "About...":
                       AboutForm anAbout = new AboutForm();
                          anAbout.ShowDialog();					
					break;
                case "-ManageCodeLists":
                    MessageBox.Show("-ManageCodeLists");
                    break;
                case "ImportCodeLists":

                    //    MessageBox.Show("Not yet implemented   import codelists");
                    DialCodeList di = new DialCodeList("import");
                    di.ShowDialog();
                    CodeLists cli = new CodeLists(Repository,"import");
       
                   
                    cli.import();
                    MessageBox.Show("the end");
                    break;
                case "ExportCodeLists":
                     
                   
                    DialCodeList de = new DialCodeList("export");
                    de.ShowDialog();
                    CodeLists cle = new CodeLists(Repository,"export");
                    cle.export();
                    cle.exportstd();
                    cle.exportext();
                    cle.toHtml();
                   // HtmlEsmpCodeListDocumentation ht = new HtmlEsmpCodeListDocumentation(Repository, CodeLists.repertoire);
                   // ht.prodDoc(Repository);
                    MessageBox.Show("the end");
                    //    MessageBox.Show("Not yet implemented export codelists");
                    
                    break;
			}
            if (!(RDFutilitaires.Barre != null)) RDFutilitaires.barreupdate(RDFutilitaires.Barre, "end");
		}

      
     
              static string nomfic; // name of the file
            public static string Nomfic  //public property
            {
                get { return nomfic; }
            
            
                set { nomfic= value; }
            }
        
        
     //traitement pour produire un fichier RDF selon l'algorithme du document 501
        /// <summary>
        ///  attention a l ordre des traitements
       ///   on cree dabord les dicos by id et by name de tous les elements du package initial
       ///   a cette occasion on  recupree tous les elements recursivement de ce package
       ///   a la volee on cree le dico by id des packages correspondants
       ///   puis on traite les classes en creant  l'entree du package la category correspondante
        /// </summary>
        /// <param name="Repository"></param>
        public void MontraitementRDF(EA.Repository Repository)

        {
            EA.Package aPackage;
            aPackage = Repository.GetTreeSelectedPackage();
     	    ConstDefinition constantes = new ConstDefinition();
           RDFutilitaires rdfutilitaires = new RDFutilitaires();
           List <EA.Element> ElemList= new List<EA.Element>();
           List<string> NoDoublons = new List<string>();

           

   /* affiche le repertoire ou se trouve le fichier  */
	   // Open an existing file, or create a new one.
        FileInfo fi = new FileInfo(aPackage.Name.ToString() + ".rdf");

        // Determine the full path of the file just created and show it
        DirectoryInfo di = fi.Directory;
              // MessageBox.Show(di.ToString()+ "\\" + aPackage.Name.ToString() + ".rdf");
        Nomfic = di.ToString() + "\\" + aPackage.Name.ToString() + "_prov.rdf";
        //TextWriter tw = new StreamWriter(Nomfic);
        StreamWriter tw = new StreamWriter(Nomfic);
	// ===report file =====

               try
                {
                  RDFutilitaires.reportlog= new StreamWriter(constantes.ReportGen); //  the report file
                    if (RDFutilitaires.ongoing == false) return;
                }
                catch (Exception e)
                {
                    MessageBox.Show(" Error when opening file " + constantes.ReportGen);
                    return;
                }
	//=====================
           RDFutilitaires.reportlog.WriteLine("--------------------------------------------------------------------------------\n\t\treport for generating profile: ");
             //   RDFutilitaires.reportlog.Write(stringtowrite);
             //   RDFutilitaires.reportlog.WriteLine("\t\t{0}", profparameters.TargetNamespace);
                RDFutilitaires.reportlog.WriteLine("\t\t rdf for {0}",aPackage.Name);
                RDFutilitaires.reportlog.WriteLine("\n\t\t Time of Generation:" + DateTime.Now + "\n");
                RDFutilitaires.reportlog.WriteLine("--------------------------------------------------------------------------------\n");
    // ======================
        // we initialize the necessary dictionaries
        EA.Collection modellist;
        modellist = Repository.Models;
        EA.Package toppack;
        toppack = RDFutilitaires.GetModelPackage(aPackage,Repository);
 

        RDFutilitaires.buildDicsElem(toppack);
        RDFutilitaires.getStereotypedElements(aPackage, ElemList,ConstantDefinition.Cimstereos );                         
	List<long> packlist=new List<long>();
        RDFutilitaires.getAllPackID(aPackage.PackageID,packlist);
            string Entete="";
Entete = Entete + "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + "\n";
Entete = Entete + "<rdf:RDF xmlns:cims=\"http://iec.ch/TC57/1999/rdf-schema-extensions-19990926#\" "; 
Entete = Entete +  "xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" ";
Entete = Entete +  "xmlns:rdfs=\"http://www.w3.org/2000/01/rdf-schema#\">";
string Finale = "</rdf:RDF>";
rdfutilitaires.datatypedone = new List<long>(); // to avoid datatype repetitions 
rdfutilitaires.dejatraite = new List<long>(); // to avoid datatype repetitions 
rdfutilitaires.nomsRoles = new List<RDFutilitaires.Nomrole>();
RDFutilitaires.LocalClassNames = new List<string>();
RDFutilitaires.buildLocalClassNames(aPackage, RDFutilitaires.LocalClassNames); 
rdfutilitaires.NoDoublons = new List<string>();  
rdfutilitaires.LocalDatatypeNames  = new List<string>();  
rdfutilitaires.LocalDatatypeIDs   = new List<long>();
RDFutilitaires.buildLocalDatatypeNames(aPackage, rdfutilitaires.LocalDatatypeNames, rdfutilitaires.LocalDatatypeIDs);     
        // impression entete
        tw.WriteLine(Entete);
	rdfutilitaires.DatatypePackageName="Domain"; // by default all the datatype are defined in a package Domain
	  foreach(long pid in packlist)
		{
        EA.Package p = RDFutilitaires.dicpackbyid[pid];
		if( p.Name=="PDomain" )  rdfutilitaires.DatatypePackageName="PDomain"; // in a profile the datatypes may be defined in Pdomain
		}
	   foreach (long pid in packlist)
	{
       EA.Package p = RDFutilitaires.dicpackbyid[pid];

	
	   rdfutilitaires.serialize(p,tw);      
	}
	
         tw.WriteLine(Finale);
         // close the stream
         tw.Flush();
         tw.Close();
   
   
            
      
 
            //-----------------------------
            string nomfichier="";
            XMLP = new XMLParser();
            if (XMLP.GetXmlValueConfig("ModeBatch")=="Checked")  // am june 2013
            {
                nomfichier = setNomFichier(aPackage, "rdf");
                System.IO.File.Copy(Nomfic, nomfichier);
            }
            else
            {
                 nomfichier = RDFutilitaires.SelectFileAndCopy(Nomfic);
            }//am june 2013
          //   theForm = new Form1();
           //  theForm.ShowDialog();
            RDFutilitaires.reportlog.WriteLine("--------------------------------------------------------------------------------\n");
            RDFutilitaires.reportlog.WriteLine("\n\t\t Time of End of Generation:" + DateTime.Now + "\n");
            RDFutilitaires.reportlog.WriteLine("--------------------------------------------------------------------------------\n");
            RDFutilitaires.reportlog.Flush();
            RDFutilitaires.reportlog.Close();
    try
            {
                string nomcible= Path.GetDirectoryName(nomfichier) + "\\" + Path.GetFileName(constantes.ReportGen);
		if(constantes.ReportGen != nomcible) {
                System.IO.File.Delete(nomcible);
                System.IO.File.Copy(constantes.ReportGen, nomcible);
		System.IO.File.Delete(constantes.ReportGen);
              }

            }
            catch (Exception e)
            {
                MessageBox.Show("Report file copy error  " + e.Message + "\n from:" + constantes.ReportGen );
            }
            MessageBox.Show(" the End");
        }
        
       static   bool isparent(EA.Element e)
        { if (e.ParentID ==  parentid) return true; else return false; }
		
        public bool readLine(StreamReader sreader)
		{
			bool answer;
			answer = false;
			
			try
			{
				filecontents = filecontents + "\n" + sreader.ReadLine();
			}
			catch
			{
				answer = true;
			}

			return answer;}
/// <summary>
/// start a process or open a document if 
/// the filename is without extent .exe
/// </summary>
/// <param name="Path"></param>
/// <param name="filename"></param>
        public static void StartProcess(string Path ,string filename)
        {
            Process myProcess = new Process();

            try
            {
              if(Path != "")
                myProcess.StartInfo.FileName = Path + "\\" + filename ;
              else myProcess.StartInfo.FileName = filename;
              //  myProcess.StartInfo.Verb = verb;
                myProcess.StartInfo.CreateNoWindow = false;
                myProcess.Start();
            }
            catch (Win32Exception e)
            {
                if (e.NativeErrorCode == ERROR_FILE_NOT_FOUND)
                {
                    Console.WriteLine(e.Message + ". Check the path.");
                }

                else if (e.NativeErrorCode == ERROR_ACCESS_DENIED)
                {
                    // Note that if your word processor might generate exceptions
                    // such as this, which are handled first.
                    Console.WriteLine(e.Message +
                        ". You do not have permission to read this file.");
                }
            }


            // On libre les ressources dont on n'a plus besoin.
            myProcess.Close(); // Attention Close ne met pas fin au processus.
        }
//---------------------------------------------------------------------------

        /// <summary>
        /// this will explore the profile
        /// starting with the package apackage
        /// and produce the XSD schemas
        /// according to WG19 NDR specs
        /// </summary>
        /// <param name="Repository"></param>
        /// <param name="?"></param>
        public void MonTraitementXSD(EA.Repository Repository,string wg)
        {
            try
            {
                Thread t = new Thread(LancBar);//am dec 2016
                if (XMLP.GetXmlValueConfig("ModeTest")!="True")
                {
                    t.Start();//am dec 2016
                }

                RDFLAutilitaires.ongoing = true;//am dec 2016
                if ((RDFutilitaires.Barre != null) && (t.IsAlive)) RDFLAutilitaires.ongoing = RDFutilitaires.Barre.go;//am dec 2016

                if (!checkgo()) return;   //am dec 2016
                EA.Package apackage = Repository.GetTreeSelectedPackage();

                if (CIMSchemaGenerator.fluxdata != null)
                {
                    CIMSchemaGenerator.fluxdata.Close();
                    System.IO.File.Delete(CIMSchemaGenerator.nomfic);
                }
                if (CIMSchemaGenerator.reportlog != null)
                {
                    CIMSchemaGenerator.reportlog.Close();
                }
            
           
            if((wg=="wg19") || (wg=="wg19byref")) {
                CIMSchemaGenerator.PackageGenerateXSD(Repository, apackage,wg);
            }
            if (wg == "wg14")
            {
                CIMSchemaGenerator.PackageGenerateXSD(Repository, apackage, "wg14");
                //CIMSchemaGenerator.GenerXSD genxsd = new CIMSchemaGenerator.GenerXSD(Repository, apackage, "wg14");
                //genxsd.Close();
            }

            if (wg == "wg16")
            {
               // CIMSchemaGenerator.PackageGenerateXSD(Repository, apackage);
                CIMSchemaGenerator.PackageGenerateXSD(Repository, apackage, "wg16");
                RDFutilitaires.barreupdate(RDFutilitaires.Barre, "end");
            }
            if (RDFutilitaires.ongoing == true)
            {

                
                MessageBox.Show("The End");
              
            }
            else
            {
                MessageBox.Show("volontarily canceled");
            }
            }
            catch (Exception e)
            {
                MessageBox.Show(" Error in dealing with xml or report files " + e.Message + "source=" + e.Source);
            }
            if (CIMSchemaGenerator.reportlog != null)
            {

                CIMSchemaGenerator.reportlog.WriteLine("--------------------------------------------------------------------------------\n");
                CIMSchemaGenerator.reportlog.WriteLine("\n\t\t Time of End of Generation:" + DateTime.Now + "\n");
                CIMSchemaGenerator.reportlog.WriteLine("--------------------------------------------------------------------------------\n");

                CIMSchemaGenerator.reportlog.Flush();
                CIMSchemaGenerator.reportlog.Close();
            }
          
}
//---------------------------------------------------------------------------
        public void MonTraitementXSDWG14(EA.Repository Repository)
        {
            EA.Package apackage = Repository.GetTreeSelectedPackage();
            CIMSchemaGenerator.PackageGenerateXSD(Repository, apackage, "wg14");
           // CIMSchemaGenerator.GenerXSD genxsd = new CIMSchemaGenerator.GenerXSD(Repository, apackage, "wg14");
            if (RDFutilitaires.ongoing == true)
            {
                if (CIMSchemaGenerator.fluxdata != null)
                {
                    CIMSchemaGenerator.fluxdata.Close();
                    System.IO.File.Delete(CIMSchemaGenerator.nomfic);
                }
                MessageBox.Show("The End");
            }
            else
            {
                MessageBox.Show("volontarily canceled");
                RDFLAutilitaires.ongoing = true;
            }
            CIMSchemaGenerator.reportlog.WriteLine("--------------------------------------------------------------------------------\n");
            CIMSchemaGenerator.reportlog.WriteLine("\n\t\t Time of End of Generation:" + DateTime.Now + "\n");
            CIMSchemaGenerator.reportlog.WriteLine("--------------------------------------------------------------------------------\n");

            CIMSchemaGenerator.reportlog.Flush();
            CIMSchemaGenerator.reportlog.Close();
        }
        //---------------------------------------------------------------------------
      public void 
          
          
          MontraitementRDFLA(EA.Repository Repository)
        {
          try{
        
      
        
           
            EA.Package aPackage;
            aPackage = Repository.GetTreeSelectedPackage();
       
            ConstDefinition constantes = new ConstDefinition();
            XMLProfileParameters profparameters = new XMLProfileParameters();
           RDFLAutilitaires rdflautilitaires = new RDFLAutilitaires(profparameters);
           DialExport aDialstereosExport = new DialExport(profparameters);
           List <EA.Element> ElemList= new List<EA.Element>();
           List<EA.Package> ListPackageProfiles = new List<Package>();
         
           string provdir = Environment.GetEnvironmentVariable("APPDATA");  // repertoire des fichiers provisoires am nov 2015
           provdir = provdir + "\\Zamiren\\CimSyntaxGen\\Ressources"; // am nov 2015
           // ===report file =====
          
           try
           {   
               RDFLAutilitaires.reportlog = new StreamWriter(Path.GetDirectoryName(XMLP.ActiveFilePath) + "\\" + "CimSyntaxGenReport.txt");
               RDFLAutilitaires.wtest("TEST"," the report file is=" + Path.GetDirectoryName(XMLP.ActiveFilePath) + "\\" + "CimSyntaxGenReport.txt"); 
               RDFutilitaires.reportlog = (StreamWriter)RDFLAutilitaires.reportlog;
           }
           catch (Exception e)
           {
               MessageBox.Show(" Error when opening file " +Path.GetDirectoryName( XMLP.ActiveFilePath) + "\\" + "CimSyntaxGenReport.txt  " + e.Message) ;
               return;
           }
           //=====================	
          /* lancement dialogue initial  */
              XMLP = new XMLParser();
           RDFutilitaires.ongoing = true;

           // we initialize the necessary dictionaries
           EA.Collection modellist;
           modellist = Repository.Models;
           EA.Package toppack = RDFutilitaires.GetModelPackage(aPackage, Repository);
           Thread t = new Thread(LancBar);
           try
           {
               if (XMLP.GetXmlValueConfig("ModeTest") != "True")
               {
                   t.Start();
               }

               RDFLAutilitaires.ongoing = true;
               
               RDFLAutilitaires.wtest("TEST", " debut construction dictionnaires");
               RDFLAutilitaires.buildDicsElem(toppack);
               RDFLAutilitaires.wtest("TEST", " fin construction dictionnaire");

             if((RDFutilitaires.Barre != null) && (t.IsAlive))   RDFLAutilitaires.ongoing = RDFutilitaires.Barre.go;
               RDFLAutilitaires.reportlog.WriteLine(" After building DicsElem  nb elements=" + RDFLAutilitaires.dicelembyid.Count.ToString() + " ongoing=" + RDFLAutilitaires.ongoing.ToString());
               if (!checkgo()) return;            
           }catch(Exception e)
           {
               
               MessageBox.Show(" Issue in building the dictionart DicsElem" + e.Message + ","  +e.GetType().ToString());
               RDFLAutilitaires.reportlog.WriteLine(" Issue in building the dictionart DicsElem" + e.Message +"," + e.GetType().ToString());
               RDFLAutilitaires.reportlog.Close();
               return;
           }

           

           RDFLAutilitaires.getStereotypedElements(aPackage, ElemList, ConstantDefinition.Cimstereos);
   
           if (XMLP.GetXmlValueConfig("ModeBatch") == "Unchecked")
           { // am june 2013

               Dialrdf aDialrdf = new Dialrdf(profparameters);
               aDialrdf.ShowDialog();
               if (RDFutilitaires.ongoing == false)
               {
                   RDFLAutilitaires.reportlog.Flush();
                   RDFLAutilitaires.reportlog.Close();

                   return; // aborted treatment
               }


               if (XMLP.GetXmlValueConfig("StereotypeNameSpaces") == "Checked")
               {
                   Option.Dialstereos aDialstereos = new Option.Dialstereos(profparameters);
                   aDialstereos.ShowDialog();
                   if (RDFutilitaires.ongoing == false)
                   {
                       RDFLAutilitaires.reportlog.Flush();
                       RDFLAutilitaires.reportlog.Close();

                       return; // aborted treatment
                   }
                   //--------------------------------------------------------------------
   
                   List<string> selectedstereotypes = new List<string>();
                   aDialstereosExport.selectedStereotypes = selectedstereotypes;
                   // List<string> l = aDialstereosExport.selectedStereotypes;
                   if (aPackage.Name == XMLP.GetXmlValueProfData("EntsoeEquipmentProfile"))
                   {
                       aDialstereosExport.ShowDialog();
                       selectedstereotypes = aDialstereosExport.selectedStereotypes;
                   }



                   //--------------------------------------------------------------------------------------
                   if (RDFutilitaires.ongoing == false)
                   {
                       RDFutilitaires.barreupdate(RDFutilitaires.Barre, "end");
                       RDFLAutilitaires.reportlog.WriteLine("  Process Interrupted  ongoing=false");
                       RDFLAutilitaires.reportlog.Flush();
                       RDFLAutilitaires.reportlog.Close();
                       return; // aborted treatment
                   }
               }
               if (!ListPackageProfiles.Contains(aPackage)) ListPackageProfiles.Add(aPackage);
           }// am june 2013
           else
           {// mode batch
               foreach (EA.Package pack in aPackage.Packages)
               {
                   if(!ListPackageProfiles.Contains(pack)) ListPackageProfiles.Add(pack);
               }
           }
          // mode batch et non batch
           LoadProfparametersfromConfig(profparameters); // am june 2013
               rdflautilitaires.NS_J0 = profparameters.RootModelURI;// +"#";
               string nomfichier = " ";
               rdflautilitaires.DatatypePackageName = XMLP.GetXmlValueProfData("EntsoeDataTypesDomain"); //"Domain"; // by default all the datatype are defined in a package Domain
               foreach (EA.Package package in ListPackageProfiles)
               {
                   RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress"); // am dec 15
                   if (!checkgo()) return; // am  janv 2016
                   if (package.Name == rdflautilitaires.DatatypePackageName) continue;
                   aPackage = package;

                   /* repertoire ou se trouve le fichier  */
                   // Open an existing file, or create a new one.                  
                   FileInfo fi = new FileInfo(aPackage.Name.ToString() + ".rdf");
                   if (System.IO.File.Exists(aPackage.Name.ToString())) System.IO.File.Delete(aPackage.Name.ToString());
                   // Determine the full path of the file just created and show it
                  // DirectoryInfo di = fi.Directory;  //am nov 2015
                   // MessageBox.Show(di.ToString()+ "\\" + aPackage.Name.ToString() + ".rdf");

                   Nomfic = provdir+ "\\" + aPackage. Name.ToString() + "_prov.rdf";

                   TextWriter tw = new StreamWriter(Nomfic);
                   dicTwbyStereotype = new Dictionary<string, TextWriter>(); // dictionary of stream writers according to export stereotypes

                   if ((profparameters.ListStereoNamespaceExport.Count > 0) && ((XMLP.GetXmlValueProfData("EntsoeEquipmentProfile") == aPackage.Name)))
                   {

                       foreach (string stereo in aDialstereosExport.selectedStereotypes)
                       {
                           if (stereo == "")
                           {
                               if (tw != null) tw.Close();
                               dicTwbyStereotype.Add(stereo, (TextWriter)new StreamWriter(provdir+ "\\" + aPackage.Name.ToString() + "_prov.rdf"));
                           }
                           else
                           {
                               dicTwbyStereotype.Add(stereo, (TextWriter)new StreamWriter(provdir + "\\" + aPackage.Name.ToString() + "-" + stereo + "_prov.rdf"));
                           }
                           RDFLAutilitaires.reportlog.WriteLine("***** entsoe export by stereos added stereotype=" + stereo);

                       }
                       // dicTwbyStereotype.Add("", tw);
                   }
                   
                   RDFLAutilitaires.reportlog.WriteLine("--------------------------------------------------------------------------------\n\t\treport for generating profile: ");
                   //   RDFLAutilitaires.reportlog.Write(stringtowrite);
                   RDFLAutilitaires.reportlog.WriteLine("\t\t rdf augmented for Profile {0}", rdflautilitaires.NS_J0);
                   //RDFLAutilitaires.reportlog.WriteLine("\t\t rdf for {0}",aPackage.Name);
                   RDFLAutilitaires.reportlog.WriteLine("\n\t\t Time of Generation:" + DateTime.Now + "\n");
                   RDFLAutilitaires.reportlog.WriteLine(" \n\t  The configuration file is in directory: " + XMLP.ActiveFilePath);
                   RDFLAutilitaires.reportlog.WriteLine("--------------------------------------------------------------------------------\n");
                   // ======================

                   List<long> packlist = new List<long>();
                   RDFLAutilitaires.getAllPackID(aPackage.PackageID, packlist);
                   string Entete = "";
                   Entete = Entete + "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + "\n";
                   Entete = Entete + "<rdf:RDF xmlns:cims=\"" + constantes.NS_CIMS + "\" ";
                   Entete = Entete + "xmlns:rdf=\"" + constantes.NS_RDF + "\" ";
                   Entete = Entete + "xmlns:xsd=\"" + constantes.NS_XSD + "\" ";
                   Entete = Entete + "xmlns:" + profparameters.Prefix + "=\"" + rdflautilitaires.NS_J0 + "\" ";
                   Entete = Entete + "xmlns:rdfs=\"" + constantes.NS_RDFS + "\"";
                   if (XMLP.GetXmlValueConfig("Xmlbase") == "Checked")
                   {
                       Entete = Entete + " xml:base=\"" + profparameters.RootModelURI.Trim('#') + "\"";
                   }
                   //Entete = Entete + ">"; //am fev 2012
                   if (XMLP.GetXmlValueConfig("StereotypeNameSpaces") == "Checked")
                   {
                       string liststereos = XMLP.GetXmlValueProfData("ListStereoNamespace");
                       string[] stereos = liststereos.Split(new char[] { '|' });
                       // verifier si les indicateurs de stereos sont positionnes
                       if (IndStereos.Count == 0)
                       {
                           //MessageBox.Show("it seems that you want to introduce classifying stereos but you do not have saved your choices \n\r (menu option)");
                           RDFLAutilitaires.InitIndStereos(stereos,XMLP);
                       }

                       string nsextensions = "";
                       List<string> prefixies = new List<string>();
                       prefixies.Add(profparameters.Prefix); // ne pas oublier le name space par default dans le test de redondance
                       foreach (string stereo in stereos)
                       {
                           string prefix = profparameters.urisbystereo[stereo][0];

                           if (!prefixies.Contains(prefix))
                           {
                               nsextensions = nsextensions + " xmlns:" + prefix + "=\"" + profparameters.urisbystereo[stereo][1] + "\" ";
                               prefixies.Add(prefix);
                           }
                       }
                       Entete = Entete + nsextensions;  // +">";
                   }
                   Entete = Entete + ">"; //am fev 2012
                   string Finale = "</rdf:RDF>";
                   rdflautilitaires.datatypedone = new List<long>(); // to avoid datatype repetitions 
                   rdflautilitaires.dejatraite = new List<long>(); // to avoid datatype repetitions 
                   rdflautilitaires.nomsRoles = new List<RDFLAutilitaires.Nomrole>(); // avoid duplicates roles name
                   RDFLAutilitaires.LocalClassNames = new List<string>();
                   RDFLAutilitaires.buildLocalClassNames(aPackage, RDFLAutilitaires.LocalClassNames);
                   rdflautilitaires.NoDoublons = new List<string>();
                   rdflautilitaires.LocalDatatypeNames = new List<string>();
                   rdflautilitaires.LocalDatatypeIDs = new List<long>();
                   RDFutilitaires.buildLocalDatatypeNames(aPackage, rdflautilitaires.LocalDatatypeNames, rdflautilitaires.LocalDatatypeIDs);
                   // impression entete
                   if ((dicTwbyStereotype.Count > 0) && (XMLP.GetXmlValueProfData("EntsoeEquipmentProfile") == aPackage.Name))  // am 271015
                   {
                       foreach (KeyValuePair<string, TextWriter> kv in dicTwbyStereotype)
                       {
                           RDFLAutilitaires.reportlog.WriteLine("entsoe export stereotype  serialization of EquipmentProfile with stereotype= " + kv.Key.ToString() + "for package=" + aPackage.Name);
                           dicTwbyStereotype[kv.Key].WriteLine(Entete);
                       }
                   }
                   else
                   {
                       RDFLAutilitaires.reportlog.WriteLine("entsoe export stereotype  serialization of EquipmentProfile wit all the stereotypes for package=" + aPackage.Name);
                       tw.WriteLine(Entete);
                   }
 
                   foreach (long pid in packlist)
                   {
                       EA.Package p = RDFLAutilitaires.dicpackbyid[pid];
                       RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress"); // am janv 2016
                       if ((dicTwbyStereotype.Count > 0) && (XMLP.GetXmlValueProfData("EntsoeEquipmentProfile") == aPackage.Name))  // am 271015
                      
                       {

                           rdflautilitaires.serialize(p, dicTwbyStereotype);


                       }
                       else
                       {
                           rdflautilitaires.serialize(p, tw);

                       }
                       if (!checkgo()) return;  // am janv 2016
                   }
                   if ((dicTwbyStereotype.Count > 0) && (XMLP.GetXmlValueProfData("EntsoeEquipmentProfile") == aPackage.Name))  // am 271015
                   {
                       foreach (KeyValuePair<string, TextWriter> kv in dicTwbyStereotype)
                       {
                           dicTwbyStereotype[kv.Key].WriteLine(Finale);
                           dicTwbyStereotype[kv.Key].Flush();
                           dicTwbyStereotype[kv.Key].Close();
                       }
                       if (tw != null) tw.Close(); // am 061115 
                   }
                   else
                   {
                       tw.WriteLine(Finale);
                       tw.Flush();
                       tw.Close();
                   }

                  // 
                   //-----------------  am oct 2015
                   Dictionary<string, string> dicIntermediatebyStereotype = new Dictionary<string, string>(); // dictionary of stream writers according to export stereotypes
                   Dictionary<string, TextReader> dicRwbyStereotype = new Dictionary<string, TextReader>();

                   //-----------------  am fev 2012
                   string newnomfic = provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf";
                   // TextReader rw = new StreamReader(Nomfic);
                   string intermediate = "";
                   if ((dicTwbyStereotype.Count > 0) && (XMLP.GetXmlValueProfData("EntsoeEquipmentProfile") == aPackage.Name))  // am 271015
                   {

                       //foreach (string stereo in profparameters.ListStereoNamespaceExport)
                       foreach (string stereo in aDialstereosExport.selectedStereotypes)
                       {
                           if (stereo == "")
                               
                           {
                               RDFLAutilitaires.wtest("TEST", "1-" + provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf");
                               dicRwbyStereotype.Add(stereo, (TextReader)new StreamReader(provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf"));
                           }
                           else
                           {
                               RDFLAutilitaires.wtest("TEST", "2-" + provdir + "\\" + aPackage.Name.ToString() + "-" + stereo + "_prov.rdf");
                               dicRwbyStereotype.Add(stereo, (TextReader)new StreamReader(provdir + "\\" + aPackage.Name.ToString() + "-" + stereo + "_prov.rdf"));
                           }
                       }
                       // dicRwbyStereotype.Add("", rw);

                       foreach (string stereo in aDialstereosExport.selectedStereotypes)
                       {
                           dicIntermediatebyStereotype.Add(stereo, dicRwbyStereotype[stereo].ReadToEnd());
                       }
                       // dicIntermediatebyStereotype.Add("", dicRwbyStereotype[""].ReadToEnd());
                       foreach (KeyValuePair<string, TextReader> kv in dicRwbyStereotype)
                       {
                           dicRwbyStereotype[kv.Key].Close();

                       }
                       //   if (tw != null) tw.Close(); 
                   }
                   else
                   {
                       RDFLAutilitaires.wtest("TEST", "3-" + Nomfic);
                       TextReader rw = new StreamReader(Nomfic);
                       intermediate = rw.ReadToEnd();
                       RDFLAutilitaires.wtest("TEST", "4-" + Nomfic);
                       rw.Close();
                       if(System.IO.File.Exists(Nomfic)) System.IO.File.Delete(Nomfic);
                   }
                   Dictionary<string, string> entities = new Dictionary<string, string>();
                   // entities.Add("&ndash;", "&#x2013;");
                   for (int i = 0; i < CD.EntityToCodes.Length; i = i + 2)
                   {
                       entities.Add(CD.EntityToCodes[i], CD.EntityToCodes[i + 1]);
                   }

                   string newinter = "";
                   string newfic = "";
                   try
                   {


                       if ((dicTwbyStereotype.Count > 0) && (XMLP.GetXmlValueProfData("EntsoeEquipmentProfile") == aPackage.Name))  // am 271015
                       {
                           foreach (string stereo in aDialstereosExport.selectedStereotypes)
                           {
                               newinter = RDFutilitaires.filterNotes(dicIntermediatebyStereotype[stereo], entities);
                               if (stereo == "")
                               {
                                   newfic = provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf";
                                   Nomfic = newfic;// legacy
                               }
                               else
                               {
                                   newfic = provdir + "\\" + aPackage.Name.ToString() + "-" + stereo + "_prov.rdf";
                               }

                               if (System.IO.File.Exists(newfic)) System.IO.File.Delete(newfic);
                               System.IO.File.AppendAllText(newfic, newinter);

                           }
  
                       }
                       else
                       {
                           RDFLAutilitaires.wtest("TEST", "4-" + provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf");
                           newinter = RDFutilitaires.filterNotes(intermediate, entities);
                           newfic = provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf";
                           Nomfic = provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf";
                          if(System.IO.File.Exists(newfic))  System.IO.File.Delete(newfic);
                           System.IO.File.AppendAllText(newfic, newinter);
                           RDFLAutilitaires.wtest("TEST", "5-" + provdir + "\\" + aPackage.Name.ToString() + "_prov.rdf");
                       }
                   }
                   catch (Exception e)
                   {
                       RDFutilitaires.barreupdate(RDFutilitaires.Barre, "end", 100);  // am janv 2016
                   MessageBox.Show("Problem in accessing some files " + e.Message); 
                   RDFLAutilitaires.reportlog.WriteLine("--------------------------------------------------------------------------------\n");
                   RDFLAutilitaires.reportlog.WriteLine("\n\t\t Time of End of Generation with error:" + DateTime.Now + "\n");
                   RDFLAutilitaires.reportlog.WriteLine("--------------------------------------------------------------------------------\n");
                   RDFLAutilitaires.reportlog.Flush();
                   RDFLAutilitaires.reportlog.Close();
                   return;
                   }
                  
                   XMLP = new XMLParser();
                   if (XMLP.GetXmlValueConfig("ModeBatch") == "Checked")  // am june 2013
                   {
                      
                       nomfichier = System.IO.Path.GetDirectoryName(Main.Repo.ConnectionString) + "\\" + setNomFichier(aPackage, "rdf");
                       RDFLAutilitaires.wtest("TEST", "6-" + nomfichier);
                       if (System.IO.File.Exists(nomfichier)) System.IO.File.Delete(nomfichier);
                       System.IO.File.Copy(Nomfic, nomfichier);
                       if (System.IO.File.Exists(Nomfic)) System.IO.File.Delete(Nomfic);
                       RDFLAutilitaires.wtest("TEST", "7-" + nomfichier);

                   }
                   else
                   {
                       nomfichier = RDFutilitaires.SelectFileAndCopy(Nomfic);
                       System.IO.File.Delete(Nomfic);
                   }//am june 2013
                   if ((dicTwbyStereotype.Count > 0) && (XMLP.GetXmlValueProfData("EntsoeEquipmentProfile") == aPackage.Name))  // am 271015
                   {
     

                       foreach (string stereo in aDialstereosExport.selectedStereotypes)
                       {

                           string nf;
                           if (stereo != "")
                           {
                               nf = provdir + "\\" + aPackage.Name.ToString() + "-" + stereo + "_prov.rdf";

                               string newnomfich = nomfichier.Remove(nomfichier.Length - 4) + "-" + stereo + ".rdf";
                               try
                               {
                                   if (System.IO.File.Exists(newnomfich))
                                   {

                                       System.IO.File.Delete(newnomfich);


                                   }
                                   System.IO.File.Copy(nf, newnomfich);
                                   System.IO.File.Delete(nf);
                               }
                               catch (Exception e)
                               {
                                   if (XMLP.GetXmlValueConfig("Log") == "Checked") XMLP.AddXmlLog("ISSUE", " Pb in dealinf with files  "+ nf + "  ;   " + newnomfich + "   " + e.Message);
                                   MessageBox.Show(" Pb in dealinf with files  " + nf + "  ;   " + newnomfich + "   " + e.Message);
                                   RDFLAutilitaires.reportlog.WriteLine(" Pb in dealinf with files  " + nf + "  ;   " + newnomfich + "   " + e.Message);
                               }
                           }

                       }
                   }
                  // RDFutilitaires.barreupdate(RDFutilitaires.Barre, "end", 100);  // am janv 2016
                   RDFLAutilitaires.reportlog.WriteLine("--------------------------------------------------------------------------------\n");
                   RDFLAutilitaires.reportlog.WriteLine("\n\t\t Time of End of Generation:" + DateTime.Now + "\n");
                   RDFLAutilitaires.reportlog.WriteLine("--------------------------------------------------------------------------------\n");

                   RDFLAutilitaires.reportlog.Flush();
  
               } // end loop on profiles package
            // Ensure that the target does not exist.
               RDFLAutilitaires.reportlog.Close();
               // MessageBox.Show(Path.GetDirectoryName(nomfichier) + "|" + Path.GetFileName(constantes.ReportGen));
           
      }catch(Exception e)
    {
        if(RDFutilitaires.Barre !=null) RDFutilitaires.barreupdate(RDFutilitaires.Barre, "end");// am janv 2016
        MessageBox.Show(" Exception dans le main " + e.Message + "," + e.InnerException.Message);
        if (RDFLAutilitaires.reportlog != null)
        {
            RDFLAutilitaires.reportlog.Flush();
            RDFLAutilitaires.reportlog.Close();
        }
    }
          RDFutilitaires.barreupdate(RDFutilitaires.Barre, "end");// am janv 2016
         
          MessageBox.Show(" the End");
       
          //   theForm = new Form1();
           //  theForm.ShowDialog();
        }

//---------------------------------------------
      static void 
          prodHtmlDocumentation(EA.Repository repo,string type)
      {
          try { 
         // MessageBox.Show(" debut de prodHtmlDocumentation"); // pour test
          XMLParser xmlp = new XMLParser();
          Thread t = new Thread(LancBarProd);
          if (XMLP.GetXmlValueConfig("ModeTest") != "True")
          {
              t.Start();
          }
          switch(type)
          {
              case "ESMPHtmlDocumentation":
         //if(xmlp.GetXmlValueConfig("Esmp")=="Checked")
         // {
         HtmlEsmpDocumentation Esmphtmldoc = new HtmlEsmpDocumentation(repo,false);
              //HtmlDocumentation htmldoc = new HtmlDocumentation(repo);
         EA.Package pac = repo.GetTreeSelectedPackage();
         if (pac.Name == "ESMPClasses") // cas particulier du 351
         {
             EA.Package packdatatype=null;
             EA.Package pa351=null;
             pa351 = repo.GetPackageByID((int)pac.ParentID);
             foreach (EA.Package pa in pa351.Packages)
             {
                 if (pa.Name == "ESMPDataTypes")
                 {
                     packdatatype = pa;
                     break;
                 }
             }
             Esmphtmldoc.is351 = true;
             if (Esmphtmldoc.is351) // cas du 351
             {
                 Esmphtmldoc.TypeList.Add("primitive", new List<long>());

                 Esmphtmldoc.listprimitive = Esmphtmldoc.buildListPrimitive(packdatatype);
             }
         }else{
             Esmphtmldoc.is351 = false;
         }
         Esmphtmldoc.prodDoc(repo,pac);
         Esmphtmldoc.docfile.WriteLine("</body>");
         Esmphtmldoc.docfile.WriteLine("</html>");
         Esmphtmldoc.docfile.Flush();
         Esmphtmldoc.docfile.Close();
         Esmphtmldoc.reportlog.Flush();
         Esmphtmldoc.reportlog.Close();
         break;
              case "ESMPHtmlDocumentationAC" :
        // HtmlEsmpDocumentation Esmphtmldocac = new HtmlEsmpDocumentation(repo,false);
         HtmlEsmpSpecificDocumentation Esmphtmldocac = new HtmlEsmpSpecificDocumentation(repo, true);

         EA.Package packselect = repo.GetTreeSelectedPackage();
         
         foreach (EA.Package pack in packselect.Packages)
         {
             Esmphtmldocac.prodDoc(repo, pack);
         }
         Esmphtmldocac.docfile.WriteLine("</body>");
         Esmphtmldocac.docfile.WriteLine("</html>");
         Esmphtmldocac.docfile.Flush();
         Esmphtmldocac.docfile.Close();
         Esmphtmldocac.reportlog.Flush();
         Esmphtmldocac.reportlog.Close();
              break;
              case "ESMPHtmlDocumentationACForIEC":
         HtmlEsmpDocumentation Esmphtmldocaciec = new HtmlEsmpDocumentation(repo,true);
         EA.Package packselectiec = repo.GetTreeSelectedPackage();
         
         foreach (EA.Package pack in packselectiec.Packages)
         {
             Esmphtmldocaciec.prodDoc(repo, pack);
         }
         Esmphtmldocaciec.docfile.WriteLine("</body>");
         Esmphtmldocaciec.docfile.WriteLine("</html>");
         Esmphtmldocaciec.docfile.Flush();
         Esmphtmldocaciec.docfile.Close();
         Esmphtmldocaciec.reportlog.Flush();
         Esmphtmldocaciec.reportlog.Close();
              break;
                  
              case "ESMPHtmlDocumentationall":
             // HtmlEsmpDocumentation Esmphtmldocall = new HtmlEsmpDocumentation(repo,false);
              HtmlEsmpSpecificDocumentation Esmphtmldocall = new HtmlEsmpSpecificDocumentation(repo, true);// correspond  contextual and assembly
              EA.Package packselecte = repo.GetTreeSelectedPackage();
                  string prov = packselecte.Name;
              foreach (EA.Package pack in packselecte.Packages)
              {

                  prov = pack.Name;
                  foreach (EA.Package pa in pack.Packages)
                  {
                      prov = pa.Name;
                     // MessageBox.Show("pa=" + prov);
                      if (pa.Name != "Business Process")
                      {
                          Esmphtmldocall.prodDoc(repo, pa);
                      }
                  }
              }
              Esmphtmldocall.docfile.WriteLine("</body>");
              Esmphtmldocall.docfile.WriteLine("</html>");
              Esmphtmldocall.docfile.Flush();
              Esmphtmldocall.docfile.Close();
              Esmphtmldocall.reportlog.Flush();
              Esmphtmldocall.reportlog.Close();
              break;

              case "ESMPHtmlDocumentationSpecific":
         // ce cas est specific  l'edition de document pour ENTSOE
         // il suppose une organisation en documet, contextual document, et assembly
      // on verifie initialemment que le repertoire d'appel  contient 2 packages
        // qui contiennent l'un le mot "assembly" et l'autre le mot contextual"
       // ou bien que nous sommes dans le cas particulier du 351  package   "ESMPClasses"
              
              EA.Package pacc = repo.GetTreeSelectedPackage();
              Boolean bon = true;
              if ((pacc.Packages.Count != 2)) // il y a bien deux documents
              {
                  MessageBox.Show(" Error: the selected directory " + "::"+ pacc.Name + " doest not contain exactly 2 documents (contextual and assembly)");
                  //Esmpspecifichtmldoc.reportlog.WriteLine(" Error: the selected directory " + "::" + pacc.Name + " doest not contain exactly 2 documents (contextual and assembly) or not 351-ESMPClasses");
                bon=false;
              }
              else
              {

                  foreach (EA.Package pa in pacc.Packages)// dans chaque package on doit trouver assembly ou contectual
                  {
                      if((!pa.Name.Contains("assembly")) &&  (!pa.Name.Contains("contextual"))
                          && (!pa.Name.Contains("Assembly")) && (!pa.Name.Contains("Contextual"))
                          )
                      {// il faut que les packages contiennent "assembly" ou "contextual"
                          MessageBox.Show(" Error: the selected directory " + "::" + pa.Name + " doest not contain A(a)ssembly or C(c)ontextual) ");
                         // Esmpspecifichtmldoc.reportlog.WriteLine(" Error: the selected directory " + "::" + pa.Name + " doest not contain Creation 351)");
                          bon=false;
                          break;
                      }
                  }
                  
              }
              if (!bon)
              {
                 // Esmpspecifichtmldoc.reportlog.Flush();
                //  Esmpspecifichtmldoc.reportlog.Close();
              }else{
              HtmlEsmpSpecificDocumentation Esmpspecifichtmldoc = new HtmlEsmpSpecificDocumentation(repo, false);
             
                  foreach (EA.Package pa in pacc.Packages)
              {
                  Esmpspecifichtmldoc.prodDoc(repo, pa);
              }
              Esmpspecifichtmldoc.docfile.WriteLine("</body>");
              Esmpspecifichtmldoc.docfile.WriteLine("</html>");
              Esmpspecifichtmldoc.docfile.Flush();
              Esmpspecifichtmldoc.docfile.Close();
              Esmpspecifichtmldoc.reportlog.Flush();
              Esmpspecifichtmldoc.reportlog.Close();
          }
          break;
                  case "HtmlENTSOEDocumentation":
          HtmlENTSOEDocumentation htmlENTSOEdoc = new HtmlENTSOEDocumentation(repo);
          htmlENTSOEdoc.prodDoc(repo);
         
          break;
                  case "HtmlHarmonisationDocumentation":
          HtmlHarmonisationDocumentation htmlharmonisationdoc = new HtmlHarmonisationDocumentation(repo);
          htmlharmonisationdoc.prodDoc(repo);

          break;
              default:
          HtmlDocumentation dhtmldoc = new HtmlDocumentation(repo);
          dhtmldoc.prodDoc(repo);
          break;
          
      }
          if (RDFutilitaires.Barre != null) RDFutilitaires.Barre.Close();

          MessageBox.Show("The end");
      }catch(Exception e){
          MessageBox.Show(" ERROR in doc production " + e.Message);
    }
      }

      /// <summary>
      /// donne le nom complet du ficher(rdf ou xcd) qui sera cr localement
      /// incremente un indice si le fichier existe dj
      /// </summary>
      /// <param name="pack"></param>
      /// <param name="type"> rdf or xsd </param> 
      /// <returns>nom du fichier</returns>
        string setNomFichier(EA.Package pack,string type)
      {
          string nomfichier = pack.Name + "." + type;
            if(System.IO.File.Exists(nomfichier))
            {
            int index=1;
              while(System.IO.File.Exists(nomfichier+"(" + index.ToString() + ")"))
              {
                  index++;
            }
              nomfichier = nomfichier + "(" + index.ToString() + ")";
            }
            return nomfichier;
      }
        /*
        static void LancBar(Object obj)
        {
            try
            {
               // RDFutilitaires.Barre = new DialGenerXSD(" be patient ....");
                
                RDFutilitaires.Barre = (DialGenerXSD)obj;
                RDFutilitaires.barreupdate(RDFutilitaires.Barre, "start", 100);
                RDFutilitaires.Barre.ShowDialog();
            }
            catch (Exception e)
            {
                RDFLAutilitaires.reportlog.Write("thread abort  " + e.Message);
                RDFutilitaires.Barre.Close();
            }
        }
        */
        static void LancBar()
        {
            try
            {
                 RDFutilitaires.Barre = new DialGenerXSD(" patience ....");

                RDFutilitaires.barreupdate(RDFutilitaires.Barre, "start", 100);
                RDFutilitaires.Barre.ShowDialog();
            }
            catch (Exception e)
            {
                RDFLAutilitaires.reportlog.Write("thread abort  " + e.Message);
                RDFutilitaires.Barre.Close();
            }
        }
        static void LancBarProd()
        {
            try
            {
                RDFutilitaires.Barre = new DialGenerXSD(" patience ....",false);

                RDFutilitaires.barreupdate(RDFutilitaires.Barre, "start", 100);
                RDFutilitaires.Barre.ShowDialog();
            }
            catch (Exception e)
            {
                RDFLAutilitaires.reportlog.Write("thread abort  " + e.Message);
                RDFutilitaires.Barre.Close();
            }
        }
        
        static void WriteY(Object obj)
        {
            EA.Package toppack = (EA.Package)obj;
            try
            {
                RDFLAutilitaires.reportlog.WriteLine(" lancement build sur le package " + toppack.Name);
                RDFLAutilitaires.buildDicsElem(toppack);
                RDFLAutilitaires.reportlog.WriteLine(" fin  build sur le package " + toppack.Name);
                /*
                int j = 0;
                for (int i = 0; i < 10000; i++)
                {

                    if (RDFLAutilitaires.reportlog != null)
                    {
                       // RDFLAutilitaires.reportlog.Write("y");
                       // RDFutilitaires.barreupdate(RDFutilitaires.Barre, "progress", 1);
                       

                    }
                    Thread.Sleep(100);
                
                }
                 *  */
            }
            catch(Exception e)
            {
                RDFLAutilitaires.reportlog.Write("thread abort  " + e.Message);
            }
        }
        void LoadProfparametersfromConfig(XMLProfileParameters profparameters) // am june 2013
        {
            XMLParser XMLP = new XMLParser();
            try{

    if (XMLP.GetXmlValueConfig("DefaultXSDFilePath") != null) profparameters.DefaultXSDFilePath = XMLP.GetXmlValueConfig("DefaultXSDFilePath");
    if (XMLP.GetXmlValueConfig("CurrentXSDFilePath") != null) profparameters.CurrentXSDFilePath = XMLP.GetXmlValueConfig("CurrentXSDFilePath");
    if (XMLP.GetXmlValueConfig("DefaultProfileNamespace") != null) profparameters.DefaultProfileNamespace = XMLP.GetXmlValueConfig("DefaultProfileNamespace");
    if (XMLP.GetXmlValueConfig("DefaultTargetNamespace") != null) profparameters.DefaultTargetNamespace = XMLP.GetXmlValueConfig("DefaultTargetNamespace");
    if (XMLP.GetXmlValueConfig("ProfileNamespace") != null) profparameters.ProfileNamespace = XMLP.GetXmlValueConfig("ProfileNamespace");
    if (XMLP.GetXmlValueConfig("TargetNamespace") != null) profparameters.TargetNamespace = XMLP.GetXmlValueConfig("TargetNamespace");
    if (XMLP.GetXmlValueConfig("DefaultRootModelURI") != null) profparameters.DefaultRootModelURI = XMLP.GetXmlValueConfig("DefaultRootModelURI");
    if (XMLP.GetXmlValueConfig("RootModelURI") != null) profparameters.RootModelURI = XMLP.GetXmlValueConfig("RootModelURI");
    if (XMLP.GetXmlValueConfig("Prefix") != null) profparameters.Prefix = XMLP.GetXmlValueConfig("Prefix");
    if (XMLP.GetXmlValueConfig("EnvelopName") != null) profparameters.EnvelopName = XMLP.GetXmlValueConfig("EnvelopName");
    //if (XMLP.GetXmlValueConfig("URICodelist") != null) profparameters.URICodelist = XMLP.GetXmlValueConfig("URICodelist");
   // if (XMLP.GetXmlValueConfig("URISchemaLocation") != null) profparameters.URISchemaLocation = XMLP.GetXmlValueConfig("URISchemaLocation");
    //if (XMLP.GetXmlValueConfig("PrefixCodelist") != null) profparameters.PrefixCodelist = XMLP.GetXmlValueConfig("PrefixCodelist");
    if (XMLP.GetXmlValueConfig("Version") != null) profparameters.Version = XMLP.GetXmlValueConfig("Version");
    if (XMLP.GetXmlValueConfig("ListStereoNamespace") != null)
    {
        string liste = XMLP.GetXmlValueConfig("ListStereoNamespace");
        string[] listns = liste.Split('|');
        foreach (string ns in listns)
        {
            if (!profparameters.ListStereoNamespace.Contains(ns))
            {
                profparameters.ListStereoNamespace.Add(ns);
            }
        }
    }
            }catch(Exception e)
            {
               // MessageBox(" Problem in reading configuration file " + e.Message);
               RDFLAutilitaires.reportlog.WriteLine(" Problem in reading configuration file " + e.Message);
            }
        }
//--------------------
//--------------- differentes receptions d'vnement -------------------------------------------
public void  EA_OnContextItemChanged(EA.Repository repo,String sguid,EA.ObjectType ot)
{
   // MessageBox.Show(" Reception evt chgt contexte guid=" + sguid + "ot=" + ot.ToString());
    if (XMLP != null)
        XMLP.AddXmlLog("EVTCONTEXT", " Reception evt chgt contexte guid=" + sguid + "ot=" + ot.ToString());
    }
 //-----------------------------------------------------

        public bool  checkgo()
        {
            bool res = true;
            if ((RDFutilitaires.Barre != null) && (!RDFutilitaires.Barre.go))
            {
                RDFLAutilitaires.reportlog.WriteLine(" the treatment has been canceled");
                RDFutilitaires.Barre.Close();
                RDFLAutilitaires.reportlog.Flush();
                RDFLAutilitaires.reportlog.Close();
                RDFLAutilitaires.ongoing = false;
                res = false;
                MessageBox.Show(" interrupted");
            }
            return res;
        }

        
        /// <summary>
        /// transfert le reportlog vers le repertoire cible
        /// on suppose le fichier reportlog ferme
        /// </summary>
        /// <param name="nomficher"></param>
        /// <param name="provdir"></param>
        /// <param name="constantes"></param>
        public void publishReportlog(string nomficher,string provdir,ConstDefinition  constantes)
        {
            try
            {

                string nomcible = Path.GetDirectoryName(nomficher) + "\\" + Path.GetFileName(constantes.ReportGen);

                //  if (constantes.ReportGen != nomcible)
                string reportgen = provdir + "\\" + Path.GetFileName(constantes.ReportGen);
                if (reportgen != nomcible)
                {
                    if (System.IO.File.Exists(nomcible)) System.IO.File.Delete(nomcible);
                    System.IO.File.Copy(reportgen, nomcible);
                    System.IO.File.Delete(reportgen);
                }

            }
            catch (Exception e)
            {
                string nomcible = Path.GetDirectoryName(nomficher) + "\\" + Path.GetFileName(constantes.ReportGen);
                MessageBox.Show("Report file copy error  " + e.Message + "\n from:" + constantes.ReportGen + "\n to: " + nomcible);
                RDFLAutilitaires.reportlog.Flush();
                RDFLAutilitaires.reportlog.Close();
            }                
        }
public string newnomfichier { get; set; }


/// <summary>
/// construction des dictionnaires du modele d'info  partir 
/// des identificateurs des packages du systeme d'info CIM sur lesquel on est baseEA.Package
/// </summary>
/// <param name="pack"></param>
void buildCIMDics( TextWriter reportlog) //List<long> cimpackageids)
{

    string texte = "";
    dicCIMElemByName = new Dictionary<string, EA.Element>();
    dicCIMElemByID = new Dictionary<long, EA.Element>();
    dicCIMElemByGUID = new Dictionary<string, EA.Element>();
    List<EA.Element> listelem = new List<EA.Element>();
    List<long> listelemid = new List<long>();
    EA.Package pack = null;
    try
    {
        if (dicCIMElemByName.Count > 0) return; // les dictionnaires sont deja remplis
        foreach (long packid in cimpackageids)
        {
            pack = Repo.GetPackageByID((int)packid);
            string prov = pack.Name + "::" + pack.Packages.Count.ToString();
            string tex = " Packages retenus du CIM " + prov;
            reportlog.WriteLine(tex);
            getTypedElements(pack, listelem, listelemid, "Class");

            //reportlog.Flush();  texte = "======   retour GetTypedList element=" + pack.Name;
            //reportlog.WriteLine(texte);
            reportlog.Flush();

        }
        foreach (EA.Element el in listelem)
        {
            string prov = el.Name;
            if ((el.Name != "") && !dicCIMElemByName.ContainsKey(el.Name))
            {

                if (!dicCIMElemByName.ContainsKey(el.Name)) dicCIMElemByName.Add(el.Name, el);
                if (!dicCIMElemByID.ContainsKey(el.ElementID)) dicCIMElemByID.Add(el.ElementID, el);
                if (!dicCIMElemByGUID.ContainsKey(el.ElementGUID)) dicCIMElemByGUID.Add(el.ElementGUID, el);
            }

        }
        //MessageBox.Show(" fin buildCIMDics "); //pour test
    }
    catch (Exception e)
    {
        Main.erreurs = Main.erreurs + 1;
        texte = "Error problem in building CIM dictionaries " + e.Message;
        reportlog.WriteLine(texte);

    }

}
//-----------------------------------
/// <summary>
/// obtient la liste des packages a partir des dependance
/// isbasedon sur les quelles le package du profile  se base
/// </summary>
/// <param name="profilepackage"></param>
void getCIMPackageslist(EA.Package pack, List<long> parentpackageids,TextWriter reportlog)
{
    ConstantDefinition CD = new ConstantDefinition();
    List<long> packageids = new List<long>(); // liste des packages IsBasedOn du package du profile
    foreach (EA.Connector con in pack.Connectors)
    {
        if ((con.Type == "Dependency") && (con.StereotypeEx.Contains(CD.GetIsBasedOnStereotype())) && (con.ClientID == pack.Element.ElementID))
        {
            EA.Package parentpack = Repo.GetPackageByID((int)Repo.GetElementByID((int)con.SupplierID).PackageID);
            string packname = Repo.GetElementByID((int)con.SupplierID).Name;
            long paid = 0;
            foreach (EA.Package pa in parentpack.Packages)
            {
                if (pa.Name == packname)
                {
                    paid = pa.PackageID;
                    break;
                }
            }
            if (paid == 0)
            {
                Main.erreurs = Main.erreurs + 1;
                string texte = "Error while searching  CIM packages";
                reportlog.WriteLine(texte);
            }
            if (!packageids.Contains(paid))
            {
                packageids.Add(paid);
                string texte = Repo.GetPackageByID((int)paid).Name;
                reportlog.WriteLine("  Package trouve de CIM : " + texte);
            }
        }
    }

    foreach (long packageid in packageids)
    {
        List<EA.Package> packagesdupack = new List<EA.Package>();
        ManageIBOUtilitaires.getAllPackages(Repo.GetPackageByID((int)packageid), packagesdupack);
        foreach (EA.Package pa in packagesdupack)
        {
            if (!parentpackageids.Contains(pa.PackageID)) parentpackageids.Add(pa.PackageID);
        }
    }
}

    }
}
		
		
	

