using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using EA;
using System.Xml;
using System.Xml.Schema;
using CimSyntaxGen;



/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.3.7                                         *    march 2019 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen.Option
{
    public partial class Dialroot : Form
    {
        private XmlSchemaElement rel;
	
        public Dialroot(XmlSchemaElement nel)
        {
            InitializeComponent();
//-------------------------------the dialog code 
            rel = nel;
            this.textBox2.Text = nel.Name ;  //RoleName
            this.textBox3.Text = "0" ;  //Min Occurs
            this.textBox1.Text = "*" ; // Max occurs
            this.label1.Text = nel.Name; // class name
         
//---------------------------------------------

        }

        //private XMLProfileParameters profparams;

        private void Dialroot_Load(object sender, EventArgs e)
        {
         
        }

    

        private void groupBox1_Enter(object sender, EventArgs e)
        {
            
        }
 
        private void button2_Click(object sender, EventArgs e)
        {
            this.rel.Name = this.textBox2.Text;
            this.rel.MinOccursString = this.textBox3.Text;
           if(this.textBox1.Text == "*") {
               this.rel.MaxOccursString="unbounded";
           }else{
               this.rel.MaxOccursString = this.textBox1.Text;
           }
           RDFutilitaires.ongoing = true;
            this.Close();

        }


        private void groupBox1_Enter_1(object sender, EventArgs e)
        {

        }

      

        private void textBox2_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == '\r')
            {
                MessageBox.Show("selected name="
                    + this.textBox2.Text);
            }
        }

        private void textBox3_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == '\r')
            {
                MessageBox.Show("selected name="
                    + this.textBox3.Text);
            }
        }
         
 

        private void textBox2_TextChanged(object sender, EventArgs e)
        {

        }

        private void Dialroot_Load_1(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            RDFutilitaires.ongoing = false;
            this.Close();
        }

  
	

    }
}
