using System;
using System.Collections.Generic;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;


/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 3.7.10                                         *    march 2019 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen.Option
{
    public partial class Dialstereos : Form
    {
       public ArrayList gblist=new ArrayList();
	
        
      private XMLProfileParameters profparams;
      private XMLParser xmlp = new XMLParser(Main.Repo);

        Dictionary<string,MonGroup> groupesparnom = new Dictionary<string,MonGroup>(); // nom, groupbox

        int index = 0;
//---------------------------------------------
       public  class MonGroup
        {
            public GroupBox mygroupbox;
            public Label mylabel;
            public CheckBox mycheckbox;
            public TextBox textbox2;  //uri
            public TextBox textbox3;  //prefix
         public    MonGroup( Dialstereos dials,GroupBox groupparent, string stereotype)
            {
               
                 
                //initialisation
                mygroupbox = new GroupBox();

                mylabel = new Label();
                mycheckbox = new CheckBox();
                textbox2 = new TextBox();
                textbox3 = new TextBox();
                mygroupbox.SuspendLayout();
                //creation
                groupparent.Controls.Add(mygroupbox);
                mygroupbox.Controls.Add(mylabel);
                mygroupbox.Controls.Add(mycheckbox);
                mygroupbox.Controls.Add(textbox3);
                mygroupbox.Controls.Add(textbox2);
                mygroupbox.Location = new System.Drawing.Point(groupparent.Location.X, groupparent.Location.Y + 50 + 42*dials.index);
                mygroupbox.Name = "groupBox" + dials.index.ToString();
                mygroupbox.Size = new System.Drawing.Size(1200, 40);
                mygroupbox.TabIndex = 23;
                mygroupbox.TabStop = false;

                // checkBox
                // 

                mycheckbox.AutoSize = true;

                mycheckbox.CheckState = CheckState.Checked;
                mycheckbox.Location = new System.Drawing.Point(5, 10);
                mycheckbox.Name = "checkBox" + dials.index.ToString();
                mycheckbox.Size = new System.Drawing.Size(40, 40);
                mycheckbox.TabIndex = dials.index;
                mycheckbox.UseVisualStyleBackColor = true;
                mycheckbox.Enabled = true;
                mycheckbox.CheckedChanged += new System.EventHandler(dials.CheckBox_Click);
                // 
                // label
                // 
                mylabel.AutoSize = true;
                mylabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                mylabel.Location = new System.Drawing.Point(mycheckbox.Location.X + 60, 10);
                mylabel.Name = "label" + dials.index.ToString();
                mylabel.Size = new System.Drawing.Size(100, 40);
                mylabel.TabIndex = 22;
                mylabel.Text = stereotype;
                // 
             


                // textBox3
                // 
                textbox3.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                textbox3.Location = new System.Drawing.Point(mylabel.Location.X + 200, 10);
                textbox3.Name = "textBox3" + dials.index.ToString();
                textbox3.Size = new System.Drawing.Size(100, 40);
                textbox3.TabIndex = 4;

                textbox3.Text = "cim";// dials.profparams.Prefix;
                textbox3.Enabled =false;
                // 
                // textBox2
                // 
                textbox2.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                textbox2.Location = new System.Drawing.Point(textbox3.Location.X + 200, 10);
                textbox2.Name = "textBox2" + dials.index.ToString();
                textbox2.Size = new System.Drawing.Size(700, 40);
                textbox2.TabIndex = 3;
                textbox2.Text = dials.profparams.DefaultRootModelURI; // dials.profparams.ProfileNamespace;
                textbox2.Enabled =  false;
                //
                if (!dials.groupesparnom.ContainsKey(mycheckbox.Name)) dials.groupesparnom.Add(mycheckbox.Name, this);
                mygroupbox.PerformLayout();
                 dials.index++;
            }       
        }
        public Dialstereos(XMLProfileParameters profparameters)
        {
            InitializeComponent();
            //-------------------------------the dialog code 
            this.profparams = profparameters;

            //this.textBox2.Text = profparameters.RootModelURI;
           // this.textBox3.Text = profparameters.Prefix;
            foreach (string s in profparameters.ListStereoNamespace)
            {
               
                    MonGroup mg= new MonGroup(this,groupBox1,s);
                

            }
        }

      
        
        private void Dialstereos_Load(object sender, EventArgs e)
        {
            /*
          
               // Create the ToolTip and associate with the Form container.
               ToolTip toolTip1 = new ToolTip();

               // Set up the delays for the ToolTip.
               toolTip1.AutoPopDelay = 5000;
               toolTip1.InitialDelay = 1000;
               toolTip1.ReshowDelay = 500;
               // Force the ToolTip text to be displayed whether or not the form is active.
               toolTip1.ShowAlways = true;

               // Set up the ToolTip text for the Button and Checkbox.
               toolTip1.SetToolTip(this.newtextbox, "My bulle");
          
           */ 
        }

        private void openFileDialog1_FileOk(object sender, CancelEventArgs e)
        {
        
        }

        private void groupBox1_Enter(object sender, EventArgs e)
        {
            MessageBox.Show("le nom du fichier est valide");
        }
 
        private void button2_Click(object sender, EventArgs e)
        {
            Main.XMLP.SetXmlValueConfig("VersionConfig", DateTime.Today.ToString("yyyy-MM-dd"));
            // this.profparams.CurrentXSDFilePath= this.label9.Text + "\\" + this.textBox1.Text ;
            foreach (Control ctl in this.groupBox1.Controls)
            {
                string prov = ctl.GetType().ToString(); //pour test
                if (typeof(GroupBox) == ctl.GetType())
                {
                    foreach (Control contr in ctl.Controls)
                    {
                        if (this.groupesparnom.ContainsKey(contr.Name))
                        {
                            MonGroup mongroup = this.groupesparnom[contr.Name];
                            if (this.profparams.urisbystereo.ContainsKey(mongroup.mylabel.Text))
                            
                                if(mongroup.textbox2.Text.EndsWith("#"))
                                { // l'uri se termine bien par un #                                
                             this.profparams.urisbystereo[mongroup.mylabel.Text][1] = mongroup.textbox2.Text;                             
                                //   this.profparams.RootModelURI = this.textBox2.Text;
                                this.profparams.urisbystereo[mongroup.mylabel.Text][0] = mongroup.textbox3.Text;
                                    //this.profparams.Prefix = this.textBox3.Text;
                                    if (this.profparams.urisbystereo[mongroup.mylabel.Text][0] != "cim")//; this.profparams.Prefix)
                                {
                                    xmlp.AddXmlProfstereo(mongroup.mylabel.Text, this.profparams.urisbystereo[mongroup.mylabel.Text][0]
                                   , this.profparams.urisbystereo[mongroup.mylabel.Text][1], null, null,null);
                                }
                                }else{
                                   
                             MessageBox.Show(" Warning one of the uri did not ended with # please fix it");
                            // MessageBox.Show(" Warning one of the uri did not ended with # it has been added");// am june 2013
                             return;
                                }

                            }
                        }
                    }
                } 
                
                CIMSchemaGenerator.profparameters = this.profparams;

            this.Close();
        }

  

        private void groupBox1_Enter_1(object sender, EventArgs e)
        {

        }

      
        /*
        private void textBox2_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == '\r')
            {
                this.profparams.TargetNamespace =  this.textBox2.Text;

                MessageBox.Show("selected name="
                    + this.profparams.TargetNamespace);
                RDFutilitaires.ongoing = true;
            }
        }
         */
        /*
        private void textBox3_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == '\r')
            {
                this.profparams.Prefix = this.textBox3.Text;

                MessageBox.Show("selected name="
                    + this.profparams.Prefix);
            }
        }
         * */
         
 

        private void textBox2_TextChanged(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            RDFutilitaires.ongoing = false;
            this.Close();
        }

        private void label1_Click(object sender, EventArgs e)
        {

        }

        private void label4_Click(object sender, EventArgs e)
        {

        }

        private void CheckBox_Click(object sender, EventArgs e)
        {
            CheckBox cb = (CheckBox)sender;
            MonGroup mongroup=this.groupesparnom[cb.Name];
            if (cb.CheckState == CheckState.Checked)
            {
                // mongroup.textbox2.Text = profparams.RootModelURI;
                // mongroup.textbox2.Text = profparams.ProfileNamespace;
                mongroup.textbox2.Text = profparams.DefaultRootModelURI; 
                mongroup.textbox2.Enabled = false;
                //mongroup.textbox3.Text = profparams.Prefix;
                mongroup.textbox3.Text = "cim";
                mongroup.textbox3.Enabled = false;
            }
            else
            {
                
                ArrayList prefixuri = this.xmlp.GetXmlProfstereo(mongroup.mylabel.Text);
                mongroup.textbox3.Text =(string) prefixuri[0];
                mongroup.textbox2.Text = (string)prefixuri[1];
                mongroup.textbox2.Enabled = true;
                mongroup.textbox3.Enabled = true;
            }
                
        }


        //--------------------------------
    }
}
