﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CimSyntaxGen.Utilities
{
    public class DialogResponse
    {
        private string fileName = null;
        private string nameSpace = null;
        private string dirName = null;
        private bool checkBoxTicked = false;

        public DialogResponse(bool canceled) 
        {
            this.Canceled = canceled;
        }

        public bool Canceled { get; set; }

        public string FileName 
        { 
            get { return fileName; }
            set { fileName = value; }
        }

        public string NameSpace
        {
            get { return nameSpace; }
            set { nameSpace = value; }
        }

        public string DirName
        {
            get { return dirName; }
            set { dirName = value; }
        }

        public bool CheckBoxTicked
        {
            get { return checkBoxTicked; }
            set { checkBoxTicked = value; }
        }

    }
}
