using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;


/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.3.7                                         *    march 2019 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen
{
    public partial class WIP : Form
    {
        public delegate void DelegateCloseWip();

        private static WIP _instance;
        private DelegateCloseWip _closeDelegate;
        private static Thread mythread;
        
        private WIP()
        {
            InitializeComponent();

            _closeDelegate = new DelegateCloseWip(InternalClose);            
        }

        public static void StartWip()
        {
            Thread InstanceCaller = new Thread(new ThreadStart(WIP.MyWipThreadFunc));
         //   Thread InstanceCaller = new Thread(WIP.MyWipThreadFunc);
            InstanceCaller.Start();
            mythread = InstanceCaller;

            while (!InstanceCaller.IsAlive) ;
           
            while (InstanceCaller.IsAlive)
            {
                Thread.Sleep(1000);
                if (_instance != null)
                {
                    _instance.pictureBox1.BringToFront();
                    _instance.label1.BringToFront();
                  
                }
                else
                {
                    MessageBox.Show(" en attente");
                }
                
            }

        }
        public static void Abort()
        {
            mythread.Abort();
            
        }

        public static void CloseWip()
        {
            try
            {
                if (_instance != null)
                    _instance.Invoke(_instance._closeDelegate);
            }
            catch (Exception ex)
            {
                if (Main.DO_REPORTLOG) RDFLAutilitaires.reportlog.WriteLine(" ERROR  myWIP "  + ex.Message);
            }
        }

        private static void MyWipThreadFunc()
        {
            _instance = new WIP();
            _instance.TopMost=true;
            _instance.ShowDialog();
        }

        private void InternalClose()
        {
            _instance.Close();
            _instance.Dispose();
        }

        private void label1_Click(object sender, EventArgs e)
        {

        }
    }
}