using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using CimSyntaxGen;


/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.3.7                                         *    march 2019 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen.Option
{
    public partial class DialCodeList : Form
    {
        XMLParser xmlp;
        string sens = "";
        public DialCodeList(string sens)
        {
             xmlp = new XMLParser(Main.Repo);
             this.sens = sens;
            InitializeComponent();
            if (sens == "import")
            {
                this.label1.Visible=true;
                this.textBox1.Text = Path.GetFileName(xmlp.GetXmlValueProfData("LastCodeListsFile"));
                this.label9.Text = Path.GetDirectoryName(xmlp.GetXmlValueProfData("LastCodeListsFile"));
                this.label9.Visible = true;
                this.label7.Visible = true;
                this.button1.Enabled = true;
                this.button1.Visible = true;
                this.textBox1.Visible = true;
                this.textBox1.Enabled = true;
                this.textBox8.Visible = false;
                this.textBox8.Enabled = false;
                this.label6.Visible = false;
            }
            else
            {
                this.button1.Enabled = false;
                this.button1.Visible = false;
                this.textBox1.Visible = false;
                this.textBox1.Enabled = false;
                this.label7.Visible = false;
                this.label9.Visible = false;
                this.label1.Visible = false;
                this.label6.Visible = true;
                this.textBox8.Text = xmlp.GetXmlValueProfData("PrefixCodelist");
                this.textBox8.Visible = true;
                this.textBox8.Enabled = true;
            }           
           
 
//---------------------------------------------

        }

        private void  DialCodeList_Load(object sender, EventArgs e)
        {
         
        }

        private void openFileDialog1_FileOk(object sender, CancelEventArgs e)
        {
        
        }

        private void groupBox1_Enter(object sender, EventArgs e)
        {
            MessageBox.Show("le nom du fichier est valide");
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (sens == "import")
            {
                openFileDialog1.Filter = "xsd files (*.xsd)|*.xsd|All files (*.*)|*.*";
                openFileDialog1.FilterIndex = 1;
                openFileDialog1.RestoreDirectory = true;
                if (openFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    //  MessageBox.Show(openFileDialog1.FileName);
                    xmlp.SetXmlValueProfData("LastCodeListsFile", openFileDialog1.FileName);

                    this.label9.Text = Path.GetDirectoryName(xmlp.GetXmlValueProfData("LastCodeListsFile"));
                    this.textBox1.Text = Path.GetFileName(xmlp.GetXmlValueProfData("LastCodeListsFile"));
                    //MessageBox.Show("fichier selectionne=" + Path.GetFileName(this.profparams.CurrentXSDFilePath));  
                }

            }
   
            



        }

        private void button2_Click(object sender, EventArgs e)
        {
            XMLParser xmlp = new XMLParser(Main.Repo);
    
         
           //-------  sauve tout ---------------------
            if (sens == "import")
            {
                xmlp.SetXmlValueProfData("LastCodeListsFile", this.label9.Text + "\\" + this.textBox1.Text);
            }
            else
            {
                xmlp.SetXmlValueProfData("PrefixCodelist", this.textBox8.Text);
            }     

           //-----------------------------------------
            
            RDFutilitaires.ongoing = true;
            this.Close();
        }

     
      

        private void button3_Click(object sender, EventArgs e)
        {
          //   = this.label9.Text + "\\" + this.textBox1.Text;          
            
            RDFutilitaires.ongoing = false;
            this.Close();
          
        }

        private void label7_Click(object sender, EventArgs e)
        {
            MessageBox.Show("directory="  +  this.label9.Text);
        }

        private void groupBox1_Enter_1(object sender, EventArgs e)
        {

        }

      

        private void textBox1_enter(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == '\r')
            {
   
                xmlp.SetXmlValueProfData("LastCodeListsFile", this.label9.Text + "\\" + this.textBox1.Text);


               // MessageBox.Show("selected file=" +  xmlp.GetXmlValueProfData("LastCodeListsFile" ));
            }
        }


    
        private void label11_Click(object sender, EventArgs e)
        {

        }

    

        private void textBox8_TextChanged(object sender, EventArgs e)
        {

        }

        private void button4_click(object sender, EventArgs e)
        {
            openFileDialog1.Filter = "xsd files (*.xsd)|*.xsd|All files (*.*)|*.*";
            openFileDialog1.FilterIndex = 1;
            openFileDialog1.RestoreDirectory = true;
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                // MessageBox.Show(openFileDialog1.FileName);
                xmlp.SetXmlValueProfData("ExtensiontXSDFilePath", openFileDialog1.FileName);
      
                // this.label9.Text = Path.GetDirectoryName(xmlp.GetXmlValueProfData("CurrentXSDFilePath"));
                // this.textBox1.Text = Path.GetFileName(xmlp.GetXmlValueProfData("CurrentXSDFilePath"));
            }


        }

        private void label6_Click(object sender, EventArgs e)
        {

        }
    }
}
