using System;
using System.Collections.Generic;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;



/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.3.7                                         *    march 2019 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen.Option
{
    public partial class DialExport: Form
    {
       public ArrayList gblist=new ArrayList();
	
        
      private XMLProfileParameters profparams;
      private XMLParser xmlp = new XMLParser(Main.Repo);

      static  Dictionary<string,CheckBox> dicCheckboxesByStereo = new Dictionary<string,CheckBox>(); // dictionnaire nomstetreotype/checkbox

        int index = 0;

            List<string> _selectedStereotypes=new List<string>();
        List<string> stereotypes = new List<string>();
        public List<string> selectedStereotypes
        {
            get
            {
                return this._selectedStereotypes;
            }
            set
            {
                stereotypes = value;
            }
        }

//---------------------------------------------
       public  class MonGroup
        {
            public GroupBox mygroupbox;
            public Label mylabel;
            public CheckBox mycheckbox;
         public    MonGroup( DialExport dials,GroupBox groupparent, string stereotype)
            {
               
                 
                //initialisation
                mygroupbox = new GroupBox();

                mylabel = new Label();
                mycheckbox = new CheckBox();
                //textbox2 = new TextBox();
               // textbox3 = new TextBox();
                mygroupbox.SuspendLayout();
                //creation
                groupparent.Controls.Add(mygroupbox);
                mygroupbox.Controls.Add(mylabel);
                mygroupbox.Controls.Add(mycheckbox);
               // mygroupbox.Controls.Add(textbox3);
               // mygroupbox.Controls.Add(textbox2);
                mygroupbox.Location = new System.Drawing.Point(groupparent.Location.X, groupparent.Location.Y + 40 + 42*dials.index);
                mygroupbox.Name = "groupBox" + dials.index.ToString();
                mygroupbox.Size = new System.Drawing.Size(1200, 40);
                mygroupbox.TabIndex = 23;
                mygroupbox.TabStop = false;

                // checkBox
                // 

                mycheckbox.AutoSize = true;

                mycheckbox.CheckState = CheckState.Checked;
                mycheckbox.Location = new System.Drawing.Point(5, 7);
                mycheckbox.Name = "checkBox" + dials.index.ToString();
                mycheckbox.Size = new System.Drawing.Size(40, 40);
                mycheckbox.TabIndex = dials.index;
                mycheckbox.UseVisualStyleBackColor = true;
                mycheckbox.Enabled = true;
                mycheckbox.CheckedChanged += new System.EventHandler(dials.CheckBox_Click);
                dicCheckboxesByStereo.Add(stereotype, mycheckbox); // memorize checkbox
                // 
                // label
                // 
                mylabel.AutoSize = true;
                mylabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
                mylabel.Location = new System.Drawing.Point(mycheckbox.Location.X+260, 7);
                mylabel.Name = "label" + dials.index.ToString();
                mylabel.Size = new System.Drawing.Size(40, 100);
                mylabel.TabIndex = 22;
                mylabel.Text = "Export " + stereotype;
                // 
             

                mygroupbox.PerformLayout();
                 dials.index++;
            }       
        }
        public DialExport(XMLProfileParameters profparameters)
        {
            InitializeComponent();
            //-------------------------------the dialog code 
            this.profparams = profparameters;
            dicCheckboxesByStereo = new Dictionary<string, CheckBox>();
            //this.textBox2.Text = profparameters.RootModelURI;
           // this.textBox3.Text = profparameters.Prefix;
            MonGroup mg = new MonGroup(this, groupBox1, "CoreEquipmentProfile");
            foreach (string s in profparameters.ListStereoNamespaceExport)
            {
               
                     mg= new MonGroup(this,groupBox1,s);

            }
             mg = new MonGroup(this, groupBox1, "all");
        }

      
        
        private void Dialstereos_Load(object sender, EventArgs e)
        {
           
        }

        private void openFileDialog1_FileOk(object sender, CancelEventArgs e)
        {
        
        }

        private void groupBox1_Enter(object sender, EventArgs e)
        {
            MessageBox.Show("le nom du fichier est valide");
        }
 
        private void button2_Click(object sender, EventArgs e)
        {
            _selectedStereotypes=new List<string>();
           foreach(KeyValuePair<string,CheckBox> kv in dicCheckboxesByStereo)
           {
             if(kv.Value.Checked)
             {
                 if(kv.Key.ToString() == "CoreEquipmentProfile")
                 {
                       _selectedStereotypes.Add("");
                 }else{
                     _selectedStereotypes.Add(kv.Key.ToString());
                 }
              
             }
           }
            
                 
                
                CIMSchemaGenerator.profparameters = this.profparams;

            this.Close();
        }

  

        private void groupBox1_Enter_1(object sender, EventArgs e)
        {

        }

      
    

        private void button1_Click(object sender, EventArgs e)
        {
            RDFutilitaires.ongoing = false;
            this.Close();
        }

        private void label1_Click(object sender, EventArgs e)
        {

        }

        private void label4_Click(object sender, EventArgs e)
        {

        }

        private void CheckBox_Click(object sender, EventArgs e)
        {
            CheckBox cb = (CheckBox)sender;
            
        }


        //--------------------------------
    }
}
