﻿using System;
using System.Collections.Generic;
using System.Text;


/*************************************************************************\
***************************************************************************
* Product CimSyntaxGen      Company :Zamiren (Joinville-le-Pont France) *
*                                      Entsoe (Bruxelles Belgique)        *
***************************************************************************
***************************************************************************                     
* Version : 2.3.7                                         *    march 2019 * 
*                                                                         *
***************************************************************************
*                                                                         *
*       Credit to:                                                        *
*                   Andre Maizener   andre.maizener@zamiren.fr            *
*                   Jean-Luc Sanson  jean-luc.sanson@noos.fr              *
*                                                                         *
*                                                                         *
*      Contact: +33148854006                                              *
*                                                                         *
***************************************************************************

**************************************************************************/
namespace CimSyntaxGen
{
    /// <summary>
    /// il s'agit de l'image d'une classe du profil qui correspond à un element EA
    /// </summary>
    class PElement
    {
        EA.Element EAElement;
        long PElementID;
        EA.Element IBO;  // element sur lequel il est base
        string IBOGuid; // le guid de l'element sur leque il est basedon


        public PElement(EA.Element el, EA.Repository repo)
        {
            EAElement = el;
            PElementID = el.ElementID;
            IBO= RDFLAutilitaires.getElementBasedonElement(el);
            IBOGuid = IBO.ElementGUID;
        }
        
    }
}
