﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CimSyntaxGen.Utilities
{
    public class StringWriterWithEncoding : StringWriter
    {
        private readonly Encoding stringWriterEncoding;
        public StringWriterWithEncoding(StringBuilder builder, Encoding desiredEncoding) : base(builder)
        {
            this.stringWriterEncoding = desiredEncoding;
        }

        public override Encoding Encoding
        {
            get
            {
                return this.stringWriterEncoding;
            }
        }
    }
}
